#include <CyberLib.h> //Библиотека от Cyber-Place.ru
//#include <Wire.h>
#include <max6675.h>
#include <EEPROM.h>
#include <PID_v1.h>
//#include <LiquidCrystal_I2C.h> //закомментировать если дисплей без I2C
//LiquidCrystal_I2C lcd(0x3f, 16, 2);  //вместо (0x3f) указываем адрес своего дисплея //закомментировать если дисплей без I2C
#include <LiquidCrystal.h> // раскомментировать если дисплей без I2C
//LiquidCrystal lcd(RW, EN, D4, D5, D6, D7);
LiquidCrystal lcd(4, 5, 6, 7, 8, 9); // раскомментировать если дисплей без I2C

uint8_t pwr_TOP;     //максимальная мощность верхнего нагревателя
uint8_t pwr_BOTTOM;  //максимальная мощность нижнего нагревателя

volatile uint8_t tic=0;
volatile uint8_t DimmerUP=220;
volatile uint8_t DimmerDOWN=220;

boolean chet = false;
boolean loadProf = false;
//RelayPin "1"-ВЕРХНИЙ нагреватель
//RelayPin "2"-НИЖНИЙ нагреватель
//#define RelayPin1 19  //назначаем пин "ВЕРХНЕГО" нагревателя
uint8_t curCount = 0;

//current editing step pointer
uint8_t editStep = 0;

byte buzzerPin = 18;

// byte intefan = 20; //внутренний вентилятор на А6
// byte extefan = 21; //внешний вентилятор на А7

  //--------------------------------------------------------------------------------------------------------------//
  //--------настройка кнопок управления------------------------------------

    //#define A_PINS_BASE 100 // номер с которого начинается нумерация наших "псевдо-кнопок".
  
 
     #define PIN_RIGHT 100
     #define PIN_UP 101
     #define PIN_DOWN 102
     #define PIN_LEFT 103
     #define PIN_SELECT 104
 
     struct A_PIN_DESC{ // определяем  структуру которой будем описывать какое значение мы ожидаем для каждого псевдо-пина
     byte pinNo; // номер пина
     int expectedValue;// ожидаемое значение
     };
 
     A_PIN_DESC expected_values[]={ // ожидаемые значения для псевдо-кнопок
     { PIN_RIGHT,0},
     { PIN_UP,144},
     { PIN_DOWN,331},
     { PIN_LEFT,506},
     { PIN_SELECT,742}
     };
 
     #define A_PINS_COUNT sizeof(expected_values)/sizeof(A_PIN_DESC) // вычисляем сколько у нас всего "псевдо-кнопок" заданно.
     #define A_POSSIBLE_ABERRATION 50 // допустимое отклонение analogRead от ожидаемого значения, 
                                 // при котором псевдо кнопка считается нажатой
 
     bool digitalReadA(byte pinNo){
   
     for(byte i=0;i<A_PINS_COUNT;i++){ // ищем описание нашего всевдо-пина
     A_PIN_DESC pinDesc=expected_values[i];// берем очередное описание
     if(pinDesc.pinNo==pinNo){ // нашли описание пина?
     int value=analogRead(A6); // производим чтетине аналогово входа
         
     return (abs(value-pinDesc.expectedValue)<A_POSSIBLE_ABERRATION); // возвращаем HIGH если отклонение от ожидаемого не больше чем на A_POSSIBLE_ABERRATION
     }
     }
   
     return LOW; // если не нашли описания - считаем что пин у нас LOW
   
     }

     //Назначаем пины кнопок управления
     byte upSwitchPin = PIN_UP;
     byte downSwitchPin = PIN_DOWN;
     byte cancelSwitchPin = PIN_LEFT;
     byte okSwitchPin = PIN_SELECT;

     //состояние кнопок по умолчанию
     boolean upSwitchState = false;
     boolean downSwitchState = false;
     boolean cancelSwitchState = false;
     boolean okSwitchState = false;

     //переменные для кнопок
     long ms_button = 0;
     boolean  button_state = false;
     boolean  button_long_state = false;
     boolean  button_state1 = false;
     boolean  button_long_state1 = false;
     
  //--------------------------------------------------------------------------------------------------------------//
  
/* //Назначаем пины кнопок управления
byte upSwitchPin = 14;
byte downSwitchPin = 15;
byte cancelSwitchPin = 16;
byte okSwitchPin = 17;

 //состояние кнопок по умолчанию
boolean upSwitchState = false;
boolean downSwitchState = false;
boolean cancelSwitchState = false;
boolean okSwitchState = false;

//переменные для кнопок
long ms_button = 0;
boolean  button_state = false;
boolean  button_long_state = false;
boolean  button_state1 = false;
boolean  button_long_state1 = false;
*/

//profile stuff
uint8_t currentProfile = 1;
uint8_t currentStep = 1;
uint8_t profileSteps;

double rampRateStep[9];

uint8_t dwellTimerStep[9];


double kp1;
double ki1;
double kd1;
double kp2;
double ki2;
double kd2;
double startTemp;

uint8_t setpointRamp;
boolean TopStart = false;
boolean flag = 0;  //флаг для фиксации стартовой температуры

int temperatureStep[9];

long previousMillis; //это для счетчиков

//double 
volatile uint8_t counter;

//Спецзнак градус цельсия
byte GC[8] = {
  0b01100,
  0b10010,
  0b10010,
  0b01100,
  0b00000,
  0b00000,
  0b00000,
  0b00000
};

byte Th[8] = {
  0b00100,
  0b01110,
  0b11111,
  0b10101,
  0b00000,
  0b10101,
  0b00000,
  0b00000
};

byte Bh[8] = {
  B00000,
  B01001,
  B10010,
  B01001,
  B00000,
  B11111,
  B11111,
  B01110,
};



//these are the different states of the sketch. We call different ones depending on conditions
// ***** TYPE DEFINITIONS *****
typedef enum REFLOW_STATE
{
  REFLOW_STATE_IDLE,
  REFLOW_STATE_MENU_STEPS,
  REFLOW_STATE_MENU_BOTTOM_HEAT,
  REFLOW_STATE_MENU_BOTTOM_PWR,
  REFLOW_STATE_MENU_STEP_RAMP,
  REFLOW_STATE_MENU_STEP_TARGET,
  REFLOW_STATE_MENU_TOP_PWR,
  REFLOW_STATE_MENU_STEP_DWELL,
  REFLOW_STATE_MENU_BOTTOM_P,
  REFLOW_STATE_MENU_BOTTOM_I,
  REFLOW_STATE_MENU_BOTTOM_D,
  REFLOW_STATE_MENU_TOP_P,
  REFLOW_STATE_MENU_TOP_I,
  REFLOW_STATE_MENU_TOP_D,
  REFLOW_STATE_STEP_RAMP,
  REFLOW_STATE_STEP,
  REFLOW_STATE_STEP_DWELL,
  REFLOW_STATE_COMPLETE,
  REFLOW_STATE_ERROR,
  REFLOW_STATE_MENU_RESET
}
reflowState_t;

typedef enum REFLOW_STATUS //this is simply to check if reflow should be running or not
{
  REFLOW_STATUS_OFF,
  REFLOW_STATUS_ON
}
reflowStatus_t;

#define SENSOR_SAMPLING_TIME 1000 //частота обновления текущей температуры (1000=1раз в секунду)
#define GRAPHICS_SAMPLING_TIME 2000 //скорость движения "звёздочек" при пайке
#define PID_SAMPLING_TIME 100 //скорость пересчета PID
reflowStatus_t reflowStatus;
// Reflow oven controller state machine state variable
reflowState_t reflowState;


//TC read timer variables
//unsigned long nextCheck1;
unsigned long nextRead1; //переменная для обновления текущей температуры
unsigned long nextRead2; //переменная для движения "звёздочек" при пайке
unsigned long nextRead3; //переменная для обновления PID
//PID stuff

double Setpoint1, Input1, Output1;
//Specify the links and initial tuning parameters
PID myPID1(&Input1, &Output1, &Setpoint1, kp1, ki1, kd1, DIRECT);

//unsigned long windowStartTime;
//PID stuff
double Setpoint2, Input2, Output2, Setpoint22;
//Specify the links and initial tuning parameters
PID myPID2(&Input2, &Output2, &Setpoint2, kp2, ki2, kd2, DIRECT);

//Alarm state boolean
boolean alarmOn = false;

//Update whole screen boolean
boolean updateScreen = true;

//назначаем пины уселителя термопары MAX6675 "НИЖНЕГО" нагревателя clk=sck cs=cs do=so
byte thermoCLK2 = 13;  //=sck
byte thermoCS2 = 10;   //=cs
byte thermoDO2 = 12;   //=so
//назначаем пины уселителя термопары MAX6675 "ВЕРХНЕГО" нагревателя   clk=sck cs=cs do=so
byte thermoCLK = 13;  //=sck
byte thermoCS = 11;   //=cs
byte thermoDO = 12;   //=so

// переменные для калмана "ВЕРХНЕГО" нагревателя
float varTerm1 = 0.25;  // среднее отклонение (ищем в excel)
float varProcess1 = 0.0125; // скорость реакции на изменение (подбирается вручную)
float Pc1 = 0.0;
float G1 = 0.0;
float P1 = 1.0;
float Xp1 = 0.0;
float Zp1 = 0.0;
float Xe1 = 0.0;

// переменные для калмана "НИЖНЕГО" нагревателя
float varTerm2 = 0.25;  // среднее отклонение (ищем в excel)
float varProcess2 = 0.0125; // скорость реакции на изменение (подбирается вручную)
float Pc2 = 0.0;
float G2 = 0.0;
float P2 = 1.0;
float Xp2 = 0.0;
float Zp2 = 0.0;
float Xe2 = 0.0;
// переменные для калм
int tc1;
int tc2;

MAX6675 thermocouple1(thermoCLK, thermoCS, thermoDO);//термопара "ВЕРХНЕГО" нагревателя
MAX6675 thermocouple2(thermoCLK2, thermoCS2, thermoDO2);//термопара "НИЖНЕГО" нагревателя

void loadProfile()//this function loads whichever profile currentProfile variable is set to
{
  profileSteps = EEPROM.read((currentProfile - 1) * 29);
  Setpoint2  = EEPROM.read((currentProfile - 1) * 29 + 1);
  Setpoint22 = Setpoint2;
  
  for (uint8_t i = 0; i < 9; i + 1) {
    rampRateStep[i] = EEPROM.read((currentProfile - 1) * 29 + i + 2);
    dwellTimerStep[i] = EEPROM.read((currentProfile - 1) * 29 + i + 11);
    temperatureStep[i] = EEPROM.read((currentProfile - 1) * 29 + i + 20);
    i++;
  }
  kp1 = EEPROM.read(480);
  ki1 = EEPROM.read(481);
  kd1 = EEPROM.read(482);
  kp2 = EEPROM.read(483);
  ki2 = EEPROM.read(484);
  kd2 = EEPROM.read(485);
  pwr_TOP = EEPROM.read(486);
  pwr_BOTTOM = EEPROM.read(487);

  return;
}
  
void initEeprom()//Запись в память начальных значений
{
  if (EEPROM.read(500) == 'C')
      {
         // чтото только для уже инициализированой памяти
      }
 else {
// профиль 1: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
           static byte rom1[]={3,150,4,2,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,1,1,1,1,1,1,
          // температуры верхнего нагревателя по 9 шагам
          150,180,190,190,205,210,215,220};
          for (uint8_t i = 0; i < 29; i++) EEPROM.write(i, rom1[i]); 
          
// профиль 2: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
          static byte rom2[] = {3,150,4,2,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,15,0,0,0,0,0,
          // температуры верхнего нагревателя по 9 шагам
          150,180,195,195,0,0,0,0};
          for (uint8_t i = 29; i < 58; i++) EEPROM.write(i, rom2[i-29]); 

// профиль 3: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
          static byte rom3[] = {3,150,4,2,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,15,0,0,0,0,0,
          // температуры верхнего нагревателя по 9 шагам
          150,180,200,195,0,0,0,0};
          for (uint8_t i = 58; i < 87; i++) EEPROM.write(i, rom3[i-58]);

// профиль 4: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
          static byte rom4[]={3,150,4,3,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,15,1,1,1,1,1,
          // температуры верхнего нагревателя по 9 шагам
          150,180,205,230,220,220,220,220,220};
          for (uint8_t i = 87; i < 116; i++) EEPROM.write(i, rom4[i-87]);
          

// профиль 5: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
          static byte rom5[]={3,150,4,3,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,15,1,1,1,1,1,
          // температуры верхнего нагревателя по 9 шагам
          150,180,210,230,220,220,220,220,220};
          for (uint8_t i = 116; i < 145; i++) EEPROM.write(i, rom5[i-116]);

// профиль 6: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
          static byte rom6[]={3,150,4,3,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,15,1,1,1,1,1,
          // температуры верхнего нагревателя по 9 шагам
          150,180,215,230,220,220,220,220,220};
          for (uint8_t i = 145; i < 174; i++) EEPROM.write(i, rom6[i-145]);

// профиль 7: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
          static byte rom7[]={3,150,4,3,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,15,1,1,1,1,1,
          // температуры верхнего нагревателя по 9 шагам
          150,180,220,230,220,220,220,220,220};
          for (uint8_t i = 174; i < 203; i++) EEPROM.write(i, rom7[i-174]);
          
// профиль 8: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
          static byte rom8[]={3,150,4,3,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,15,1,1,1,1,1,
          // температуры верхнего нагревателя по 9 шагам
          150,220,225,230,220,220,220,220,220};
          for (uint8_t i = 203; i < 232; i++) EEPROM.write(i, rom8[i-203]);
                    
// профиль 9: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
          static byte rom9[]={3,150,4,3,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,15,1,1,1,1,1,
          // температуры верхнего нагревателя по 9 шагам
          150,220,230,230,220,220,220,220,220};
          for (int i = 232; i < 261; i++) EEPROM.write(i, rom9[i-232]);
                    
// профиль 10: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
          static byte rom10[]={3,150,4,3,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,15,1,1,1,1,1,
          // температуры верхнего нагревателя по 9 шагам
          150,220,235,230,220,220,220,220,220};
          for (int i = 261; i < 290; i++) EEPROM.write(i, rom10[i-261]);

                    
// профиль 11: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
          static byte rom11[]={3,150,4,3,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,15,1,1,1,1,1,
          // температуры верхнего нагревателя по 9 шагам
          150,220,240,230,220,220,220,220,220};
          for (int i = 290; i < 319; i++) EEPROM.write(i, rom11[i-290]);

                              
// профиль 12: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
          static byte rom12[]={3,150,4,3,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,15,1,1,1,1,1,
          // температуры верхнего нагревателя по 9 шагам
          150,220,245,230,220,220,220,220,220};
          for (int i = 319; i < 348; i++) EEPROM.write(i, rom12[i-319]);

                              
// профиль 13: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
          static byte rom13[]={3,150,4,3,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,15,1,1,1,1,1,
          // температуры верхнего нагревателя по 9 шагам
          150,220,250,230,220,220,220,220,220};
          for (int i = 348; i < 377; i++) EEPROM.write(i, rom13[i-348]);

                              
// профиль 14: шаги, температура низа, 9 скоростей роста температуры шага умноженое на 4
          static byte rom14[]={3,150,4,3,4,4,4,4,4,4,4,
          // 9 продолжительностей шага
          1,1,15,15,1,1,1,1,1,
          // температуры верхнего нагревателя по 9 шагам
          150,220,255,230,220,220,220,220,220};
          for (int i = 377; i < 406; i++) EEPROM.write(i, rom14[i-377]);

          static byte rom15[]={
// PID верха, Kd умноженое на 100, Ki Rd умноженое на 10
          55,7,30,
// PID низа, Kd умноженое на 100, Ki Rd умноженое на 10
          63,3,30,
// ограниченеи мощности верха и низа в процентах *2
          80,170};
          for (int i = 480; i < 488; i++) EEPROM.write(i, rom15[i-480]);
          
// Записываем метку CFG о том что в памяти уже есть значения
          EEPROM.write(500, 'C');
          }
         
         lcd.clear();
         lcd.setCursor(0,0);
         lcd.print("EEPROM"); 
         lcd.setCursor(0,1);
         
         for (uint8_t i=0; i<10; i++) {
          lcd.print("*");
          delay(200);
         }
}

void sReset() {
  asm volatile ("jmp 0");
}


void setup()
{
  D15_Out; D3_Out; //верхний и нижний выходы нагревателей
  D15_Low; D3_Low; //верхний и нижний выходы установить на выходах низкий уровень сигнала
  D2_In; //настраиваем порт на вход для отслеживания прохождения сигнала через ноль  
  
//CHANGE – прерывание вызывается при любом изменении значения на входе; 
//RISING – вызов прерывания при изменении уровня напряжения с низкого (Low) на высокий(HIGH) 
//FALLING – вызов прерывания при изменении уровня напряжения с высокого (HIGH) на низкий (Low) 
    attachInterrupt(0, detect, FALLING);  // настроить срабатывание прерывания interrupt0 на pin 2 на низкий уровень
    StartTimer1(halfcycle, 50); //время для одного разряда ШИМ 50мкс
    
  
 //  Serial.begin(9600); 
  //setup pins as input for buttons
  
  
  //-------------------------------------------------------------------------------------//
  
  pinMode (upSwitchPin, INPUT);
  // digitalWrite(upSwitchPin, HIGH); //подключаем подтягивающий резистор
  pinMode (downSwitchPin, INPUT);
  // digitalWrite(downSwitchPin, HIGH); //подключаем подтягивающий резистор
  pinMode (cancelSwitchPin, INPUT);
  // digitalWrite(cancelSwitchPin, HIGH); //подключаем подтягивающий резистор
  pinMode (okSwitchPin, INPUT);
  // digitalWrite(okSwitchPin, HIGH); //подключаем подтягивающий резистор
   
  pinMode (buzzerPin, OUTPUT);

  //-------------------------------------------------------------------------------------//

  /* pinMode(intefan, OUTPUT); //внутренний вентилятор
  pinMode(extefan, OUTPUT); //внешний вентилятор
  digitalWrite(intefan, LOW); //внутренний вентилятор выключить
  digitalWrite(extefan, LOW); //внешний вентилятор выключить
  */
  
  //------------------------------------------------------------------------------------//
  
  //собщение приветствия
  //lcd.begin(); // закомментировать если дисплей без I2C
  lcd.begin(16, 2); // раскомментировать если дисплей без I2C
// Для дисплеея спецсимвол Градус целсия ....
  lcd.createChar(0, GC);
  lcd.createChar(1, Th);
  lcd.createChar(2, Bh);
// и его печать
// lcd.write(byte(0));

  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print(" ARDUINO REWORK");
  lcd.setCursor(0, 1);
  lcd.print(" v2.0.5 MAX6675");
    
  //Мелодия приветствия
  tone(buzzerPin, 523);
  delay(200);
  tone(buzzerPin, 659);
  delay(200);
  tone(buzzerPin, 784);
  delay(200);
  tone(buzzerPin, 1046);
  delay(200);
  noTone(buzzerPin);
  // wait for MAX chips to stabilize and splash screen
  delay(1000);
  initEeprom();
  lcd.clear();

  nextRead1 = millis();

  myPID1.SetMode(AUTOMATIC);
  myPID2.SetMode(AUTOMATIC);
  }

int i = 0;

void loop()
{

  //---------------------------------------------------------------------------------------------------------//
  
       //Считываем состояние кнопок управления
       upSwitchState = digitalReadA(upSwitchPin);
       downSwitchState = digitalReadA(downSwitchPin);
       cancelSwitchState = digitalReadA(cancelSwitchPin);
       okSwitchState = digitalReadA(okSwitchPin);
  
  //---------------------------------------------------------------------------------------------------------//
  
  
  /* //Считываем состояние кнопок управления
  upSwitchState = !digitalRead(upSwitchPin);
  downSwitchState = !digitalRead(downSwitchPin);
  cancelSwitchState = !digitalRead(cancelSwitchPin);
  okSwitchState = !digitalRead(okSwitchPin);
  */

  unsigned long currentMillis = millis();
  
    
  int SP1 = Setpoint1;
  int SP2 = Setpoint22;

//бузер при нажатии на кнопки (нервирует), кому надо раскоментируйте ниже 6 строк
//  if (upSwitchState == HIGH || downSwitchState == HIGH || cancelSwitchState == HIGH || okSwitchState == HIGH)
//  {
//    tone(buzzerPin, 1045);
//    delay(100);
//    noTone(buzzerPin);
//  }


  if (reflowState == REFLOW_STATE_COMPLETE || alarmOn) {
    if (i < 2 && cancelSwitchState == LOW) {
      alarmOn = true;
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      i++;
    }
    else {
      i = 0;
      alarmOn = false;
    }
  }

  switch (reflowState)
  {
    case REFLOW_STATE_IDLE:
     TopStart = false;
     currentStep = 1;
     counter = 0;
     setpointRamp = 0;

     flag = 0;         //после остановки профиля сбрасываем флаг
     DimmerUP=220;
     DimmerDOWN=220;

      lcdTemp();

      //Update whole screen only once
      if (updateScreen) {
        //Настройка экрана в режиме ожидания
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("IDLE ");
        lcd.setCursor(0, 1);
        lcd.print("Pr  ");
        lcd.setCursor(5, 0);
        lcd.write(byte(1));
        lcd.setCursor(5, 1);
        lcd.write(byte(2));
        lcd.write(byte(2));

        updateScreen = false;
      }
      lcd.setCursor(2, 1);
      lcd.print(currentProfile, HEX);

      if (temperatureStep[profileSteps-2]<181) {lcd.print("+");
      lcd.write(byte(2));}
      else {lcd.print("-");
      lcd.write(byte(2));}

      lcd.setCursor(7, 0);
      lcd.print(temperatureStep[profileSteps-1]);
      lcd.write(byte(0));
      lcd.setCursor(7, 1);
      lcd.print(SP2);
      lcd.write(byte(0));
      
    
      if (upSwitchState == HIGH && ( millis() - ms_button)>500)//if up switch is pressed go to next profile
      {
        ms_button =  millis();
        currentProfile = currentProfile + 1;
        loadProf= false;
        if (currentProfile >= 14)//if currentProfile = 14 and up is pressed go back to profile 1
        {
          currentProfile = 1;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>500)//same as above just go down one profile
      {
        ms_button =  millis();
        currentProfile = currentProfile - 1;
        loadProf= false;
        if (currentProfile <= 0)
        {
          currentProfile = 14;
        }
      }
      //читаем из eeprom и перенастраиваем ПИД если изменили профиль
      if (!loadProf) {
      loadProfile();
      myPID1.SetTunings(kp1/10, ki1/100, kd1/100);
      myPID2.SetTunings(kp2/10, ki2/100, kd2/100);
      myPID1.SetOutputLimits(0, pwr_TOP);
      myPID2.SetOutputLimits(0, pwr_BOTTOM);
      }
      loadProf= true;
      
//фиксируем момент нажатия кнопки "ОК" + защита от дребезга
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
        button_long_state = false;
      }
//держим "ОК" 5 секунд и заходим в меню настроек      
      if (okSwitchState == HIGH && !button_long_state && ( millis() - ms_button)>5000)
      {
        button_long_state = true;
        button_state = false;
        reflowState = REFLOW_STATE_MENU_STEPS;
        //update next screen
        updateScreen = true;
      }

      //фиксируем момент нажатия кнопки "Cancel" + защита от дребезга
      if (cancelSwitchState == HIGH && !button_state1 && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state1 = true;
        button_long_state1 = false;
        // digitalWrite(intefan, LOW); //внутренний вентилятор выключить
        // digitalWrite(extefan, LOW); //внешний вентилятор выключить
      }
//держим "Cancel" 8 секунд и стираем память      
      if (cancelSwitchState == HIGH && !button_long_state1 && ( millis() - ms_button)>8000)
      {
        button_long_state1 = true;
        ms_button =  millis();
        button_state1 = false;
        reflowState = REFLOW_STATE_MENU_RESET;
        updateScreen = true;
      }
         if (cancelSwitchState == LOW && button_long_state1) button_long_state1 = false;
//включаем пайку, кнопка сработает после отпускания "ОК" если нажатие меньше 3х секунд       
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        tone(buzzerPin, 1045, 500);  //звуковой сигнал при старте профиля
        updateScreen = true;
        curCount = 0;
        nextRead2 = millis();
        reflowStatus = REFLOW_STATUS_ON;
        reflowState = REFLOW_STATE_STEP_RAMP;
      }
      break;
//устанавливаем количество шагов профиля
    case REFLOW_STATE_MENU_STEPS:
      if (updateScreen) {
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("Profile ");
        lcd.print(currentProfile);
        lcd.print(" Edit");
        lcd.setCursor(0, 1);
        lcd.print("Profile Steps: ");
        lcd.print(profileSteps);
        updateScreen = false;
      }
      lcd.setCursor(15, 1);
      lcd.print(profileSteps);

      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        profileSteps = profileSteps + 1;
        if (profileSteps >= 10) {
        profileSteps = 9;
       }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        profileSteps = profileSteps - 1;
        if (profileSteps <= 1) 
        {
          profileSteps = 1;
        }
      }
      if (okSwitchState == LOW && button_long_state) button_long_state = false; //чтобы после входа в меню не кнопка "ОК" не считалась нажатой
      
      if (okSwitchState == HIGH && !button_state && !button_long_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_HEAT;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }

      break;

//Стираем всю память и переходим в начало 
      case REFLOW_STATE_MENU_RESET:
         lcd.clear();
         lcd.setCursor(0,0);
         lcd.print("EEPROM formatted");
            for (int i = 0; i < 512; i++){
              EEPROM.write(i, 255);
            }
         sReset();
         //reset();
      break;
//устанавливаем температуру "Нижнего Нагревателя"
    case REFLOW_STATE_MENU_BOTTOM_HEAT:

      if (updateScreen) {
        lcd.setCursor(0, 1);
        lcd.print("Bottom Heat:      ");        
        updateScreen = false;
      }
      lcd.setCursor(12, 1);
      lcd.print(Setpoint2,0);
      lcd.write(byte(0));
      lcd.print(" ");

      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        Setpoint2 = Setpoint2 + 1;
        if (Setpoint2 >= 200)
        {
          Setpoint2 = 200;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        Setpoint2 = Setpoint2 - 1;
        if (Setpoint2 <= 80)
        {
          Setpoint2 = 80;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_PWR;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
      
 //устанавливаем максимальную мощность "НИЖНЕГО НАГРЕВАТЕЛЯ"     
   case REFLOW_STATE_MENU_BOTTOM_PWR:
      
      if (updateScreen)
      {
        
        lcd.setCursor(0, 1);
        lcd.print("Bottom PWR:     ");        
        updateScreen = false;
      }
      lcd.setCursor(12, 1);      
      lcd.print(pwr_BOTTOM/2);
      lcd.print("%");
      
      
      
     if (pwr_BOTTOM<=199)
      {      
      lcd.setCursor(15,1);
      lcd.print(" ");
      }
       if (pwr_BOTTOM<=19)
      {      
      lcd.setCursor(14,1);
      lcd.print("  ");
      }
      
       if (upSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        pwr_BOTTOM = pwr_BOTTOM + 1;
        if (pwr_BOTTOM >= 200)
        {
          pwr_BOTTOM = 200;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        pwr_BOTTOM = pwr_BOTTOM - 1;
        if (pwr_BOTTOM <= 0)
        {
         pwr_BOTTOM = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_TOP_PWR;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

 //устанавливаем максимальную мощность "ВЕРХНЕГО НАГРЕВАТЕЛЯ"      
       case REFLOW_STATE_MENU_TOP_PWR:
      
      if (updateScreen)
      {
        
        lcd.setCursor(0, 1);
        lcd.print("TOP PWR:     ");        
        updateScreen = false;
      }
      lcd.setCursor(12, 1);      
      lcd.print(pwr_TOP/2);
      lcd.print("%");
      
      
      
      if (pwr_TOP<=199)
      {      
      lcd.setCursor(15,1);
      lcd.print(" ");
      }
       if (pwr_TOP<=19)
      {      
      lcd.setCursor(14,1);
      lcd.print("  ");
      }
      
       if (upSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        pwr_TOP = pwr_TOP + 1;
        if (pwr_TOP >= 200)
        {
          pwr_TOP = 200;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)
      {
        ms_button =  millis();
        pwr_TOP = pwr_TOP - 1;
        if (pwr_TOP <= 0)
        {
         pwr_TOP = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_STEP_RAMP;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
      
//устанавливаем скорость нагрева "Верхним Нагревателем"
    case REFLOW_STATE_MENU_STEP_RAMP:

      if (updateScreen) {
        lcd.setCursor(0, 1);
        lcd.print("Step");
        lcd.print(editStep + 1);
        lcd.print(" Ramp:    ");
        updateScreen = false;
      }
      lcd.setCursor(11, 1);
      lcd.print(rampRateStep[editStep] / 4);
      lcd.write(byte(0));
      lcd.print(" ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        rampRateStep[editStep] = rampRateStep[editStep] + 1.;
        if (rampRateStep[editStep] >= 12.)  //(только целые числа) максимальная скорость роста температуры делённая на 4
        {
          rampRateStep[editStep] = 12.;  //(только целые числа) максимальная скорость роста температуры делённая на 4
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        rampRateStep[editStep] = rampRateStep[editStep] - 1.;
        if (rampRateStep[editStep] <= 1.)  //(только целые числа) минимальная скорость роста температуры делённая на 4
        {
          rampRateStep[editStep] = 1.;  //(только целые числа) минимальная скорость роста температуры делённая на 4
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profileSteps) {
          editStep = 0;
          reflowState = REFLOW_STATE_MENU_STEP_TARGET;
        }
        else {
          editStep++;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        lcd.clear();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//устанавливаем температуру "Верхнего Нагревателя"
    case REFLOW_STATE_MENU_STEP_TARGET:
      if (updateScreen) {
        lcd.setCursor(0, 1);
        lcd.print("Step");
        lcd.print(editStep + 1);
        lcd.print(" Target:");
        lcd.print(temperatureStep[editStep]);
        lcd.print("  ");
        updateScreen = false;
      }
      lcd.print(" ");
      lcd.setCursor(13, 1);
      lcd.print(temperatureStep[editStep]);
      lcd.print("   ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        temperatureStep[editStep] = temperatureStep[editStep] + 1;
        if (temperatureStep[editStep] >= 255)
        {
          temperatureStep[editStep] = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        temperatureStep[editStep] = temperatureStep[editStep] - 1;
        if (temperatureStep[editStep] <= 0)
        {
          temperatureStep[editStep] = 0;
        }
        if (temperatureStep[editStep] <= 99)
        {
          lcd.setCursor(13, 1);
          lcd.print("  ");
        }
        if (temperatureStep[editStep] <= 9)
        {
          lcd.setCursor(13, 1);
          lcd.print("   ");
        }
      }

      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profileSteps) {
          editStep = 0;
          reflowState = REFLOW_STATE_MENU_STEP_DWELL;
        }
        else {
          editStep++;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//устанавливаем время перехода на следующий шаг
    case REFLOW_STATE_MENU_STEP_DWELL:

      if (updateScreen) {
        lcd.setCursor(0, 1);
        lcd.print("Step ");
        lcd.print(editStep + 1);
        lcd.print(" Dwell:");
        lcd.print(dwellTimerStep[editStep]);
        lcd.print("c ");
      }
      lcd.print("  ");
      lcd.setCursor(13, 1);
      lcd.print(dwellTimerStep[editStep]);
      lcd.print("c ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        dwellTimerStep[editStep] = dwellTimerStep[editStep] + 1;
        if (dwellTimerStep[editStep] >= 255)
        {
          dwellTimerStep[editStep] = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        dwellTimerStep[editStep] = dwellTimerStep[editStep] - 1;
        if (dwellTimerStep[editStep] <= 0)
        {
          dwellTimerStep[editStep] = 0;
        }

      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>150)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profileSteps) {

          editStep = 0;
          reflowState = REFLOW_STATE_MENU_BOTTOM_P;
        }
        else {
          editStep++;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//настройка "ПИД" нижнего нагревателя
    case REFLOW_STATE_MENU_BOTTOM_P:
      if (updateScreen) {
        lcd.setCursor(0, 1);
    //    lcd.print("                  ");
//      lcd.setCursor(3, 2);
        lcd.print("B.Heat: ");
        lcd.setCursor(8, 1);
        lcd.print("P=");
        lcd.print(kp2/10);
        lcd.print("    ");
        updateScreen = false;
      }
      lcd.setCursor(10, 1);
      lcd.print(kp2/10);
      lcd.print("  ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kp2 = kp2 + 1;
        if (kp2 >= 255)
        {
          kp2 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kp2 = kp2 - 1;
        if (kp2 <= 0)
        {
          kp2 = 0;
        }

      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_I;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
    case REFLOW_STATE_MENU_BOTTOM_I:
      lcd.setCursor(8, 1);
      lcd.print("I=");
      lcd.print(ki2/100);
      lcd.print(" ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        ki2 = ki2 + 1;
        if (ki2 >= 255)
        {
          ki2 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        ki2 = ki2 - 1;
        if (ki2 <= 0)
        {
          ki2 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        reflowState = REFLOW_STATE_MENU_BOTTOM_D;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    case REFLOW_STATE_MENU_BOTTOM_D:
      lcd.setCursor(8, 1);
      lcd.print("D=");
      lcd.print(kd2/100);
      lcd.print("      ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kd2 = kd2 + 1;
        if (kd2 >= 255)
        {
          kd2 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kd2 = kd2 - 1;
        if (kd2 <= 0)
        {
          kd2 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>150)
      {        
        ms_button =  millis();
        button_state = false;
        reflowState = REFLOW_STATE_MENU_TOP_P;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//настройка "ПИД" верхнего нагревателя
    case REFLOW_STATE_MENU_TOP_P:
      if (updateScreen) {
        lcd.setCursor(0, 1);
    //    lcd.print("                  ");
    //    lcd.setCursor(5, 2);
        lcd.print("T.Heat: ");
        lcd.setCursor(8, 1);
        lcd.print("P=");
        lcd.print(kp1/10);
        lcd.print("    ");
        updateScreen = false;
      }
      lcd.setCursor(10, 1);
      lcd.print(kp1/10);
      lcd.print("    ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kp1 = kp1 + 1;
        if (kp1 >= 255)
        {
          kp1 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kp1 = kp1 - 1;
        if (kp1 <= 0)
        {
          kp1 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_TOP_I;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
    case REFLOW_STATE_MENU_TOP_I:
      lcd.setCursor(8, 1);
      lcd.print("I=");
      lcd.print(ki1/100);
      lcd.print("     ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        ki1 = ki1 + 1;
        if (ki1 >= 255)
        {
          ki1 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        ki1 = ki1 - 1;
        if (ki1 <= 0)
        {
          ki1 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
        reflowState = REFLOW_STATE_MENU_TOP_D;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    case REFLOW_STATE_MENU_TOP_D:
      lcd.setCursor(8, 1);
      lcd.print("D=");
      lcd.print(kd1/100);
      lcd.print("     ");
      if (upSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kd1 = kd1 + 1;
        if (kd1 >= 255)
        {
          kd1 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        kd1 = kd1 - 1;
        if (kd1 <= 0)
        {
          kd1 = 0;
        }

      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>200)
      {        
        ms_button =  millis();
        button_state = false;
//сохраняем текущие параметры в "Память"
        EEPROM.write((currentProfile - 1) * 29, profileSteps);
        EEPROM.write((currentProfile - 1) * 29 + 1, Setpoint2);
        for (uint8_t i = 0; i < 9; i + 1) {
          EEPROM.write(((currentProfile - 1) * 29 + i + 2), rampRateStep[i] );
          EEPROM.write(((currentProfile - 1) * 29 + i + 11), dwellTimerStep[i]);
          EEPROM.write(((currentProfile - 1) * 29 + i + 20), temperatureStep[i]);
          i++;
        }
        EEPROM.write(480, kp1);
        EEPROM.write(481, ki1);
        EEPROM.write(482, kd1);
        EEPROM.write(483, kp2);
        EEPROM.write(484, ki2);
        EEPROM.write(485, kd2);
        
        EEPROM.write(486, pwr_TOP);
        EEPROM.write(487, pwr_BOTTOM);

        
        lcd.clear();
        reflowState = REFLOW_STATE_IDLE;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        lcd.clear();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//"процесс пайки", рост температуры с заданной скоростью
    case REFLOW_STATE_STEP_RAMP:
      //currentStep = 1;
      if (updateScreen) {
        lcd.setCursor(0, 0);
        lcd.print(" RUN");
        lcd.setCursor(11, 0);
        lcd.print(" ");
        lcd.setCursor(11, 1);
        lcd.print("*");
        updateScreen = false;
      }
  //если температура низа на 10 градусов приблизилась к установленой включаем верх нагреватель
  //  if ((tc2 >= Setpoint22-10)&& (!TopStart)) TopStart=!TopStart;   
    
    if (TopStart ==true)   
    {
    // если включен верхний нагшреватель рисуем обе звездочки
        lcd.setCursor(11, 1);
        lcd.print("*");
        lcd.setCursor(11, 0);
        lcd.print("*");
    }   
    
//фиксируем стартовую температуру      
        if (flag == 0) { 
        startTemp = tc1;
        // digitalWrite(intefan, HIGH); //внутренний вентилятор включить 
        //(обдув вентилятором радиаторов симистора или твердотельного реле)
        flag = 1;}

      lcd.setCursor(4, 0);
      lcd.print(currentStep);
//      lcd.print(" ");
      lcd.setCursor(7, 1);
      lcd.print(SP2);
      lcd.write(byte(0));
      lcd.print("*");
     // ramp rate counter;
      
//счётчик скорости роста температуры                  
      if ((currentMillis - previousMillis) > 4000 / rampRateStep[currentStep - 1])  //seconds counter
       {
        previousMillis = currentMillis;
        counter = counter + 1;
        setpointRamp = counter + startTemp;
        lcd.setCursor(7, 0);
        lcd.print("   ");       
        lcd.setCursor(7, 0);
        lcd.print(setpointRamp);
        lcd.write(byte(0));
        
        if (setpointRamp<100) {
        lcd.print(" ");
        }

        if (Setpoint22 >= setpointRamp)
              { 
              Setpoint2 = setpointRamp;
              }
        else {
              Setpoint1 = setpointRamp;
              }
       }       
//----------------------------------------------------------------------------------------       
     
      if (setpointRamp >= temperatureStep[currentStep - 1]) //если достигли нужной температуры
      {
        TopStart=true;
        lcd.setCursor(7, 0);
        lcd.print(temperatureStep[currentStep - 1]);
        lcd.write(byte(0));
// рисуем звездочку включения верхнего нагревателя - хотя включается по достижению 

        lcd.setCursor(11, 0);
        lcd.print("*");
        flag = 0;
        reflowState = REFLOW_STATE_STEP;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
        updateScreen = true;
      }
      break;

    case REFLOW_STATE_STEP:
      Setpoint1 = temperatureStep[currentStep - 1];
      if (Input1 >= temperatureStep[currentStep - 1])
      {
        counter = 0;
        reflowState = REFLOW_STATE_STEP_DWELL;        
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;
        
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//считаем время перехода на следующий шаг
    case REFLOW_STATE_STEP_DWELL:
    if ((profileSteps == currentStep) && (counter == 0))  //если достигли максимальной температуры профиля на  последнем шаге 
        {
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100); 
        }
      if (currentMillis - previousMillis > 1000) 
      {
        previousMillis = currentMillis;
        counter = counter + 1;
      }
      if (counter == dwellTimerStep[currentStep - 1]) //если счётчик равен установленному времени
      {
        counter = 0;
        setpointRamp = 0;
        if (profileSteps == currentStep) //если достигли последнего шага 
        {
          currentStep = 1;
          flag = 0;
          TopStart = false; //после завершения профиля сбрасываем флаг
          reflowState = REFLOW_STATE_COMPLETE;
          // digitalWrite(extefan, HIGH); //внешний вентилятор включить
        }
        else //если шаг не последний
        {          
          currentStep++; //переходим на следующий шаг
          reflowState = REFLOW_STATE_STEP_RAMP;          
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button)>150)
      {
        ms_button =  millis();
        updateScreen = true;    
        
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;
//завершение пайки      
    case REFLOW_STATE_COMPLETE:
      
      reflowStatus = REFLOW_STATUS_OFF;
      reflowState = REFLOW_STATE_IDLE;
      updateScreen = true;
      
      break;
  }
  
//включение нагревателей
  if (reflowStatus == REFLOW_STATUS_ON)
  {
    if (millis() > nextRead2) {
      
      nextRead2 += GRAPHICS_SAMPLING_TIME;
      if (curCount == 0) {
        lcd.setCursor(0, 0);
        lcd.print("*");
        lcd.setCursor(5, 0);
        lcd.write(byte(1));
        curCount = 1;
      }
      else {
        lcd.setCursor(0, 0);
        lcd.print(" ");
        lcd.setCursor(5, 0);
        lcd.print(" ");
        curCount = 0;
      }
     }
      
      lcdTemp();

    if (millis() > nextRead3)
    {
      nextRead3 += PID_SAMPLING_TIME;

    if (!TopStart) DimmerUP=220;
    else {
      myPID1.Compute();
      DimmerUP=map(Output1,0,200,200,16);
      }
       myPID2.Compute();
    DimmerDOWN=map(Output2,0,200,200,16);
//    if (!flag) DimmerDOWN=220;
    }
    
     /*--------------------------------------------------   
    Serial.print(" TOP ");
    Serial.print("  ");
    Serial.print(Input1,0);
    Serial.print("  ");
    Serial.print(Setpoint1,0);
    Serial.print("  ");
    Serial.print(Output1, 0);
    Serial.print("  ");
    Serial.print(DimmerUP);
    Serial.print("  ");
    Serial.print(TopStart,BIN);
    Serial.print("  ");
    Serial.print("Bottom ");
    Serial.print("  ");
    Serial.print(Input2, 0);
    Serial.print("  ");
    Serial.print(Setpoint2,0);
    Serial.print("  ");
    Serial.print(Output2, 0);
    Serial.print("  ");
    Serial.print(DimmerDOWN);
    Serial.print("  ");
    Serial.print(flag,BIN);
    Serial.print("  ");
    Serial.print(tc2-Setpoint22);
    Serial.println("  ");
   ------------------------------------------------------------- */
    
  }
  else
  {
    D3_Low;
    D15_Low;
  }
}

void halfcycle()  //прерывания таймера
{ 
  tic++;  //счетчик  
  if((DimmerUP < tic) && (chet))   D15_High; //управляем выходом
  if((DimmerDOWN < tic) && (!chet)) D3_High;  //управляем выходом
}

void  detect()  // обработка внешнего прерывания.
{
 D15_Low; D3_Low; //логический ноль на выходы 
 tic=0;       //обнулить счетчик
 chet=!chet; //ЧЕТНОСТЬ ПОЛУВОЛНЫ
} 

  float filter1(float val_1) {  //функция фильтрации показений "Верхней" термопары
  Pc1 = P1 + varProcess1;
  G1 = Pc1/(Pc1 + varTerm1);
  P1 = (1-G1)*Pc1;
  Xp1 = Xe1;
  Zp1 = Xp1;
  Xe1 = G1*(val_1-Zp1)+Xp1; // "фильтрованное" значение
  return(Xe1);
  }

  float filter2(float val_2) {  //функция фильтрации показений "Нижней" термопары
  Pc2 = P2 + varProcess2;
  G2 = Pc2/(Pc2 + varTerm2);
  P2 = (1-G2)*Pc2;
  Xp2 = Xe2;
  Zp2 = Xp2;
  Xe2 = G2*(val_2-Zp2)+Xp2; // "фильтрованное" значение
  return(Xe2);
  }

void lcdTemp()
{
      if (millis() > nextRead1)
      {    
        // Read thermocouples next sampling period
        nextRead1 += SENSOR_SAMPLING_TIME;
        //устраняем колебания датчиков температуры                
        Input1 = filter1(thermocouple1.readCelsius());
        Input2 = filter2(thermocouple2.readCelsius());
        tc1 = Input1;
        tc2 = Input2; 

/* --------------------------------------------------------------------
        // вывод на комп через UART 
        char buf[32];
        sprintf (buf, "OK%03d%03d%03d%03d\r\n", int(Output1/2), int(Output2/2), tc1, tc2); 
        // БУФЕР
        Serial.print(buf); // ВЫВОД
   ------------------------------------------------------------- */      

        lcd.setCursor(12, 0);
        lcd.print("    ");
        lcd.setCursor(12, 0);
        if (isnan(Input1)) {
          lcd.print("Er");
          lcd.print(" ");
        } else {
          lcd.print(tc1);
          lcd.write(byte(0));
          lcd.print(" ");
        }
        lcd.setCursor(12, 1);
        lcd.print("    ");
        lcd.setCursor(12, 1);
        if (isnan(Input2)) {
          lcd.print("Er");
          lcd.print(" ");
        } else {
          lcd.print(tc2);
          lcd.write(byte(0));
          lcd.print(" ");
        }
      }
}
